SystemOrganization addCategory: #'Pier-Twitter-View'!
SystemOrganization addCategory: #'Pier-Twitter-Model'!

Object subclass: #PTTwitter
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Twitter-Model'!

PTTwitter subclass: #PTStatus
	instanceVariableNames: 'text created'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Twitter-Model'!

!PTStatus class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 13:45'!
descriptionCreated
	^ MAStringDescription new
		xmlName: #'created_at';
		accessor: #created;
		beRequired;
		yourself! !

!PTStatus class methodsFor: 'accessing-description' stamp: 'lr 6/11/2008 14:34'!
descriptionText
	^ MAMemoDescription new
		xmlName: #text;
		accessor: #text;
		beRequired;
		yourself! !

!PTStatus class methodsFor: 'accessing' stamp: 'lr 6/11/2008 14:32'!
xmlName
	^ #status! !

!PTStatus methodsFor: 'accessing' stamp: 'lr 6/11/2008 14:39'!
created
	^ created! !

!PTStatus methodsFor: 'accessing' stamp: 'lr 6/11/2008 14:39'!
created: aDate
	created := aDate! !

!PTStatus methodsFor: 'accessing' stamp: 'lr 6/11/2008 14:38'!
text
	^ text! !

!PTStatus methodsFor: 'accessing' stamp: 'lr 6/11/2008 14:37'!
text: aString
	text := aString! !

!PTTwitter class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:31'!
descriptionId
	^ MANumberDescription new
		xmlName: #id;
		accessor: #id;
		beRequired;
		yourself! !

!PTTwitter class methodsFor: 'instance-creation' stamp: 'lr 6/11/2008 13:45'!
new
	^ self basicNew initialize! !

!PTTwitter class methodsFor: 'instance-creation' stamp: 'lr 6/11/2008 13:51'!
newFrom: anXml
	^ self new initializeFrom: anXml! !

!PTTwitter class methodsFor: 'accessing' stamp: 'lr 6/11/2008 14:25'!
xmlName
	^ nil! !

!PTTwitter methodsFor: 'comparing' stamp: 'lr 6/11/2008 13:41'!
= anObject
	^ self species = anObject species and: [ self id = anObject id ]! !

!PTTwitter methodsFor: 'actions' stamp: 'lr 7/9/2008 13:31'!
flush! !

!PTTwitter methodsFor: 'comparing' stamp: 'lr 7/9/2008 13:30'!
hash
	^ self id hash! !

!PTTwitter methodsFor: 'accessing' stamp: 'lr 6/11/2008 13:50'!
id
	^ id! !

!PTTwitter methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:31'!
id: anInteger
	id := anInteger! !

!PTTwitter methodsFor: 'initialize-release' stamp: 'lr 7/9/2008 13:41'!
initialize! !

!PTTwitter methodsFor: 'initialize-release' stamp: 'lr 6/11/2008 14:37'!
initializeFrom: anXml
	| value |
	self description do: [ :each |
		each xmlName notNil ifTrue: [
			value := anXml elementAt: each xmlName.
			(value isNil and: [ each isRequired ])
				ifTrue: [ self error: each label , ' is a required field' ].
			value isNil
				ifFalse: [ self write: (each fromString: value contentString) using: each ] ] ]! !

PTTwitter subclass: #PTUser
	instanceVariableNames: 'username nickname summary location url image protected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Twitter-Model'!

PTUser subclass: #PTAccount
	instanceVariableNames: 'email password followers friends timeline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Twitter-Model'!

!PTAccount methodsFor: 'private' stamp: 'lr 7/9/2008 13:28'!
call: anUrl class: aClass
	| response result |
	response := HTTPSocket
		httpGet: anUrl
		args: Dictionary new
		user: email 
		passwd: password.
	response isString
		ifTrue: [ self error: 'Could not access ' , anUrl printString ].
	result := OrderedCollection new.
	(XMLDOMParser parseDocumentFrom: response readStream)
		tagsNamed: aClass xmlName
		do: [ :each | result add: (aClass newFrom: each) ].
	^ result! !

!PTAccount methodsFor: 'accessing' stamp: 'lr 6/11/2008 13:38'!
email
	^ email! !

!PTAccount methodsFor: 'accessing' stamp: 'lr 6/11/2008 13:38'!
email: aString
	email := aString! !

!PTAccount methodsFor: 'actions' stamp: 'lr 7/9/2008 13:31'!
flush
	super flush.
	followers := friends := timeline := nil! !

!PTAccount methodsFor: 'querying' stamp: 'lr 7/9/2008 13:21'!
followers
	"Answer the authorized user's followers' current status."
	
	^ followers ifNil: [ followers := self call: 'http://twitter.com/statuses/followers.xml' class: PTUser ]! !

!PTAccount methodsFor: 'querying' stamp: 'lr 7/9/2008 13:21'!
friends
	"Answer the authorized user and their friends' current status."
	
	^ friends ifNil: [ friends := self call: 'http://twitter.com/statuses/friends.xml' class: PTUser ]! !

!PTAccount methodsFor: 'accessing' stamp: 'lr 6/11/2008 13:38'!
password
	^ password! !

!PTAccount methodsFor: 'accessing' stamp: 'lr 6/11/2008 13:38'!
password: aString
	password := aString! !

!PTAccount methodsFor: 'querying' stamp: 'lr 7/9/2008 13:21'!
timeline
	"This command returns the authorized user's timeline."
	
	^ timeline ifNil: [ timeline := self call: 'http://twitter.com/statuses/user_timeline.xml' class: PTStatus ]! !

!PTUser class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:40'!
descriptionImage
	^ MAStringDescription new
		xmlName: #'profile_image_url';
		accessor: #image;
		yourself! !

!PTUser class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:38'!
descriptionLocation
	^ MAStringDescription new
		xmlName: #location;
		accessor: #location;
		yourself! !

!PTUser class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:41'!
descriptionNickname
	^ MAStringDescription new
		xmlName: #'screen_name';
		accessor: #nickname;
		yourself! !

!PTUser class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:42'!
descriptionProtected
	^ MABooleanDescription new
		xmlName: #protected;
		accessor: #protected;
		yourself! !

!PTUser class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:44'!
descriptionSummary
	^ MAMemoDescription new
		xmlName: #description;
		accessor: #summary;
		yourself! !

!PTUser class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:38'!
descriptionUrl
	^ MAStringDescription new
		xmlName: #url;
		accessor: #url;
		yourself! !

!PTUser class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:40'!
descriptionUsername
	^ MAStringDescription new
		xmlName: #name;
		accessor: #username;
		yourself! !

!PTUser class methodsFor: 'instance-creation' stamp: 'lr 7/9/2008 13:15'!
email: anEmailString password: aPasswordString
	^ PTAccount new
		email: anEmailString;
		password: aPasswordString;
		yourself! !

!PTUser class methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:29'!
xmlName
	^ #user! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
image
	^ image! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
image: anObject
	image := anObject! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
location
	^ location! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
location: anObject
	location := anObject! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
nickname
	^ nickname! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
nickname: anObject
	nickname := anObject! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
protected
	^ protected! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
protected: anObject
	protected := anObject! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
summary
	^ summary! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
summary: anObject
	summary := anObject! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
url
	^ url! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
url: anObject
	url := anObject! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
username
	^ username! !

!PTUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:40'!
username: anObject
	username := anObject! !

PRWidget subclass: #PRTwitterClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Twitter-View'!

!PRTwitterClient class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:46'!
descriptionCount
	^ MASingleOptionDescription new
		label: 'Number of updates';
		options: (1 to: 20);
		accessor: #count;
		priority: 200;
		default: 3;
		yourself! !

!PRTwitterClient class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:47'!
descriptionPassword
	^ MAPasswordDescription new
		accessor: #password;
		label: 'Username';
		priority: 110;
		default: '';
		yourself! !

!PRTwitterClient class methodsFor: 'accessing-descriptions' stamp: 'lr 7/9/2008 13:47'!
descriptionUsername
	^ MAStringDescription new
		accessor: #username;
		label: 'Username';
		priority: 100;
		default: '';
		yourself! !

!PRTwitterClient class methodsFor: 'testing' stamp: 'lr 6/11/2008 08:28'!
isAbstract
	^ false! !

!PRTwitterClient class methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:47'!
label
	^ 'Twitter Client'! !

!PRTwitterClient methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:58'!
account
	self owner properties at: #'twitter.updated' ifPresent: [ :date |
		date + self timeout < DateAndTime now
			ifTrue: [ self owner properties removeKey: #'twitter.account' ifAbsent: [ ] ] ].
	^ self owner properties at: #'twitter.account' ifAbsentPut: [ 
		self owner 
			propertyAt: #'twitter.updated'
			put: DateAndTime now.
		PTAccount
			email: self username
			password: self password ]! !

!PRTwitterClient methodsFor: 'accessing' stamp: 'lr 6/11/2008 08:31'!
count
	^ self read: #descriptionCount! !

!PRTwitterClient methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:54'!
password
	^ self read: #descriptionPassword! !

!PRTwitterClient methodsFor: 'rendering' stamp: 'lr 7/9/2008 14:02'!
renderContentOn: html
	| timeline |
	timeline := self account timeline.
	timeline := timeline first: (timeline size min: self count).
	html unorderedList class: 'twitter'; with: [
		timeline do: [ :each |
			html listItem: [ 
				html span: each text.
				html anchor
					url: each url;
					with: each created ] ] ]! !

!PRTwitterClient methodsFor: 'accessing' stamp: 'lr 7/9/2008 13:58'!
timeout
	^ 1 hour! !

!PRTwitterClient methodsFor: 'accessing' stamp: 'lr 6/11/2008 09:35'!
username
	^ self read: #descriptionUsername! !

!PRTwitterClient methodsFor: 'private' stamp: 'lr 7/9/2008 13:59'!
write: anObject using: aDescription
	self owner properties removeKey: #'twitter.account' ifAbsent: [ ].
	super write: anObject using: aDescription! !

!MADescription methodsFor: '*pier-twitter-model' stamp: 'lr 6/11/2008 13:49'!
xmlName
	^ self propertyAt: #xmlName ifAbsent: [ nil ]! !

!MADescription methodsFor: '*pier-twitter-model' stamp: 'lr 6/11/2008 13:49'!
xmlName: aString
	self propertyAt: #xmlName put: aString! !
